package rabbit.dcs;

import android.content.Context;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.graphics.Color;
import android.graphics.Point;
import android.os.Bundle;
import android.os.Parcelable;
import android.view.Display;
import android.view.MotionEvent;
import android.view.View;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.ImageButton;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.ToggleButton;

import androidx.appcompat.app.AppCompatActivity;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;

public class ConvertActivity extends AppCompatActivity implements SelectionOwner {

    private static ConvertActivity _convertActivity;

    ScrollManager _scrollManager = new ScrollManager();

    static final int _HSV_ROWOFFSET = 40;

    static final int _ROW_SCROLL_OFFSET = 166;

    public static ConvertActivity getContext() {
        return _convertActivity;
    }

    @Override
    public void finish() {
        if (!_isPinning) {
            // ピン止めでなければ閉じる
            super.finish();
        }
    }

    @Override
    public void finishActivity (int requestCode) {
        if (!_isPinning) {
            // ピン止めでなければ閉じる
            super.finishActivity(requestCode);
        }
    }

    @Override
    protected void onStart() {
        super.onStart();
    }

    @Override
    protected void onResume() {
        super.onResume();
    }

    @Override
    protected void onStop() {
        super.onStop();
    }

    @Override
    protected void onDestroy () {
        super.onDestroy();
// ConvertActivity 以外のサブ・アクティビティは不要か？
//DEBUG        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_UNSPECIFIED);
    }

    SelectionControler _selectionControler;

    boolean _isInit;

    boolean _isPinning;

    @Override
    public void onWindowFocusChanged(boolean hasFocus) {
        super.onWindowFocusChanged(hasFocus);

        if (_isInit) {
            return;
        }
        _isInit = true;
        Button bOk = findViewById(R.id.bOk);
        RecyclerView rvList = findViewById(R.id.rvList);
        if (rvList.getChildCount() == 0) {
            bOk.setEnabled(false);
        }
        MainActivity.setButtonColor(bOk);
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
try {
		setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        setContentView(R.layout.activity_convert);
        _convertActivity = this;

        MainActivity mainActivity = MainActivity.getContext();
        _selectionControler = new SelectionControler(this) {

            @Override
            public int getSelectedCount() {
                return ConvertActivity.this.getSelectedCount();
            }

            @Override
            public void setSelectedCount(int count) {
                ConvertActivity.this.setSelectedCount(count);
                Button bOk = findViewById(R.id.bOk);
                bOk.setEnabled(count > 0);
                MainActivity.setButtonColor(bOk);
            }

            @Override
            public RecyclerView getRecyclerViewList() {
                return findViewById(R.id.rvList);
            }

            @Override
            public CheckBox getCheckBoxSelectAll() {
                return findViewById(R.id.cbSelectAll);
            }
        };
        setTitle(MainActivity._values.title);
// リスナー登録
// 変換
        // 変　換／取消しボタン
        Button bOk = findViewById(R.id.bOk);
        bOk.setText(MainActivity._values.convert);
        bOk.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                executeConvert();
            }
        });
        Button bCancel = findViewById(R.id.bCancel);
        bCancel.setText(MainActivity._values.cancel);
        bCancel.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                ConvertActivity.super.finish();
            }
        });
        CheckBox cbSeletAll = findViewById(R.id.cbSelectAll);
        cbSeletAll.setText(MainActivity._values.selectAll);
// ピン止め
        ToggleButton tbPinninng = findViewById(R.id.tbPinning);
        tbPinninng.setTextOn("");
        tbPinninng.setTextOff("");
        _isPinning = String.valueOf(true).equals(
                mainActivity.getProperty(MainActivity._property_key_pinning_conv));
        tbPinninng.setChecked(_isPinning);
        tbPinninng.setBackgroundResource(_isPinning? R.drawable.pinning1: R.drawable.pinning0);
        tbPinninng.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton cbPinning, boolean isChecked) {
                tbPinninng.setBackgroundResource(isChecked?
                        R.drawable.pinning1: R.drawable.pinning0);
                _isPinning = isChecked;
                mainActivity.setProperty(MainActivity._property_key_pinning_conv, String.valueOf(isChecked));
            }
        });
        RecyclerView rvList = findViewById(R.id.rvList);
        // 上端／下端ボタン
        ImageButton ibDown = findViewById(R.id.ibDown);
        MainActivity.createTouchListener(ibDown, Color.argb(100, 200, 255, 100), new TouchCallback() {
            @Override
            public void execute() {
                MainActivity.setDownList(rvList);
            }
        });
        ImageButton ibUp = findViewById(R.id.ibUp);
        MainActivity.createTouchListener(ibUp, Color.argb(100, 200, 255, 100), new TouchCallback() {
            @Override
            public void execute() {
                MainActivity.setUpList(rvList);
            }
        });
        // 上端／下端ボタンの背景色を設定
        int iDown, iUp;
        iUp = R.mipmap.ic_arrow_up_winter;
        iDown = R.mipmap.ic_arrow_down_winter;
        ibUp.setImageResource(iUp);
        ibDown.setImageResource(iDown);
//
        RecyclerView.LayoutManager rLayoutManager = new LinearLayoutManager(this);
        rvList.setLayoutManager(rLayoutManager);

        Intent intent = getIntent();
        Bundle bundle = intent.getExtras();
        Parcelable[] list = bundle.getParcelableArray(MainActivity.KEY_LIST);
        ConvertAdapter adapter = new ConvertAdapter(list);
        _selectionControler.setAdapter(adapter);
//
        int bgcolor = MainActivity.getSeasonColor(MainActivity._W_BGCOLOR);
        View view = findViewById(R.id.activity_convert);
        view.setBackgroundColor(bgcolor);
        MainActivity.setButtonColor(bOk);
        MainActivity.setButtonColor(bCancel);
//
        rvList.setOnTouchListener(new View.OnTouchListener() {
            @Override
            public boolean onTouch(View view, MotionEvent evt) {
                switch (evt.getAction()) {
                    default:
                        break;
                    case MotionEvent.ACTION_DOWN:
                        _scrollManager.isContains(rvList, evt.getRawX(), evt.getRawY(), "initializing");
                        break;
                    case MotionEvent.ACTION_MOVE:
                        _scrollManager.moveTo(rvList, evt.getRawX(), evt.getRawY(), false, "initializing");
                        break;
                    case MotionEvent.ACTION_UP:
                        _scrollManager._isInside = false;
                        break;
                    case MotionEvent.ACTION_CANCEL:
                        break;
                }
                return false;
            }
        });
        } catch(Exception e) {
            if (MainActivity._ERROR_LOG) {
                RLog.e("Dcs", e.getMessage(), e);
            }
        }
    }

    View.OnTouchListener _listener = new View.OnTouchListener() {
        @Override
        public boolean onTouch(View view, MotionEvent evt) {
            switch (evt.getAction()) {
                default:
                    break;
                case MotionEvent.ACTION_DOWN:
                    _scrollManager.isContains((RecyclerView) MainActivity.getParent(view, R.id.rvList), evt.getRawX(), evt.getRawY(), "initializing");
                    break;
                case MotionEvent.ACTION_MOVE:
                    _scrollManager.moveTo((RecyclerView) MainActivity.getParent(view, R.id.rvList), evt.getRawX(), evt.getRawY(), false, "initializing");
                    break;
                case MotionEvent.ACTION_UP:
                    _scrollManager._isInside = false;
                    break;
                case MotionEvent.ACTION_CANCEL:
                    break;
            }
            return false;
        }
    };

    void setListeners(View parent, ConvertAdapter.ViewHolder holder) {
        WindowManager wm = (WindowManager)getSystemService(Context.WINDOW_SERVICE);
        Display disp = wm.getDefaultDisplay();
        Point rp = new Point();
        disp.getRealSize(rp);
        int[] sl = new int[2];

        RecyclerView rvList = findViewById(R.id.rvList);
        View view = parent.findViewById(R.id.hsvRow);
        // HorizontalScrollView の最短幅（右端）
        view.setMinimumWidth(rp.x - (sl[0] == 0? _HSV_ROWOFFSET: sl[0]));
        view.setHorizontalScrollBarEnabled(false);
        view.setOnTouchListener(_listener);
//
        view = parent.findViewById(R.id.tvInfo);
        // HorizontalScrollView の最短幅（右端）
        view.setMinimumWidth(rp.x - (sl[0] == 0? _HSV_ROWOFFSET: sl[0]));
        view.setOnTouchListener(_listener);
//
        CheckBox cbSelect = parent.findViewById(R.id.cbSelect);
        cbSelect.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                _selectionControler.onSelected((CheckBox) view);
                holder.rowInfo.isSelected = ((CheckBox)view).isChecked();
            }
        });
    }

    public int getSelectedCount() {
        TextView tvCount = findViewById(R.id.tvCount);
        return Integer.parseInt(((String)tvCount.getText()).trim());
    }

    public void setSelectedCount(int count) {
        TextView tvCount = findViewById(R.id.tvCount);
        tvCount.setText(String.valueOf(count));
    }

    void executeConvert() {
        try {
            int[] astype = new int[1];
            int[] adtype = new int[1];
            int[] atype = new int[1];
            int[] altype = new int[1];
            DcsConvertObserver[] observer = new DcsConvertObserver[1];
            Dcs dcs = createDcs(astype, adtype, observer);
            RecyclerView rvList = findViewById(R.id.rvList);
            DcsAdapter adapter = (DcsAdapter) rvList.getAdapter();
            if (adapter == null) {
if (MainActivity._ERROR_LOG) {
RLog.e("Dcs", "ConvertActivity.executeConvert: RecyclerView.getAdapter() == null");
}
                return;
            }
            int i, ccnt, len = adapter.getItemCount();
            int scnt = getSelectedCount();
            RowInfo[] ainfo = new RowInfo[scnt];

            for (i = ccnt = 0; i < len; i++) {
                RowInfo info = adapter.getRowInfo(i);
                if (info.isSelected) {
                    dcs.convertFile(info.path, astype[0], adtype[0], false, observer[0], observer[0], info);
                    if (info.os != null) {
                        try {
                            // OutputStream が設定されている場合、閉じる
                            info.os.close();
                        } catch(IOException e) {
                            if (MainActivity._ERROR_LOG) {
                                RLog.e("Dcs", e.getMessage(), e);
                            }
                        }
                        info.os = null;
                    }
                    // RowInfo を更新
                    MainActivity.judgesFile(dcs, atype, altype, info);
                    ainfo[ccnt++] = info;
                    if (ccnt >= scnt) {
                    // 全て処理した時
                        break;
                    }
                }
            }
            dcs.close();
//
            // RowInfo 更新
            MainActivity mainActivity = MainActivity.getContext();
            mainActivity.restoreRowInfo(ainfo);
 // 再描画
            LinearLayout llPath = mainActivity.findViewById(R.id.llPath);
            mainActivity.gotoWithIndex(llPath.getChildCount() - 1);
        } catch(DcsException e) {
if (MainActivity._ERROR_LOG) {
RLog.e("Dcs", e.getMessage(), e);
}
        }
        super.finish();
    }

    static Dcs createDcs(int[] astype, int[] adtype, DcsConvertObserver[] observer) throws DcsException {
        MainActivity mainActivity = MainActivity.getContext();
        String sstype = mainActivity.getProperty(MainActivity._property_key_stype);
        String sdtype = mainActivity.getProperty(MainActivity._property_key_dtype);
        astype[0] = SettingsActivity.nameToType(sstype);
        adtype[0] = SettingsActivity.nameToType(sdtype);
        boolean isMac1char = String.valueOf(true).equals(mainActivity.getProperty(MainActivity._property_key_mac1char));
        boolean isLnEdit = String.valueOf(true).equals(mainActivity.getProperty(MainActivity._property_key_ln_edit));
        String sln = mainActivity.getProperty(MainActivity._property_key_ln_dest);
        boolean[] isOverrSame = {String.valueOf(true).equals(mainActivity.getProperty(MainActivity._property_key_overr_same))};
        boolean[] isOverrSimilar = {String.valueOf(true).equals(mainActivity.getProperty(MainActivity._property_key_overr_similar))};
//
        Dcs dcs = new Dcs();
        dcs.setLtype(SettingsActivity.nameToLtype(isLnEdit? sln: null));
        dcs.setUtfmacTo(isMac1char);
        observer[0] = new DcsConvertObserver() {
            @Override
            public int observe(int sts, Object userInfo) {
                if (!Dcs.CONFIRMED_CODE_TYPE(sts)) {
                // 確定コード・タイプの範囲外の時
                    return Dcs.OBS_STOP;
                }
                if (!isOverrSame[0]) {
                // 上書き不可の時
                    if (sts == adtype[0]
                    || sts == Dcs.ASCII && Dcs.remainsAscii(adtype[0])) {
                    // 判定コードと出力コードが等しい時
                    // 又は判定コードがASCIIかつ変換後もASCIIの時
                        ((RowInfo)userInfo).sts = RowInfo.STS_WOVERR;
                        return Dcs.OBS_STOP;
                    }
                }
                if (!isOverrSimilar[0]) {
                // 類似コード上書き不可の時
                    switch(sts) {
                        case Dcs.JIS:
                        case Dcs.JIS2:
                            switch(adtype[0]) {
                                case Dcs.JIS:
                                case Dcs.JIS2:
                                    ((RowInfo)userInfo).sts = RowInfo.STS_WOVERR;
                                    return Dcs.OBS_STOP;
                            }
                            break;
                        case Dcs.EUC:
                        case Dcs.EUC1:
                        case Dcs.EUC2:
                        case Dcs.EUC3:
                            switch(adtype[0]) {
                                case Dcs.EUC:
                                case Dcs.EUC1:
                                case Dcs.EUC2:
                                case Dcs.EUC3:
                                    ((RowInfo)userInfo).sts = RowInfo.STS_WOVERR;
                                    return Dcs.OBS_STOP;
                            }
                            break;
                    }
                }
                // 出力ファイル・オープン
                RowInfo info = (RowInfo) userInfo;
                File file = new File(info.path);
                try {
                    info.os = new BufferedOutputStream(new FileOutputStream(file));
                } catch (FileNotFoundException e) {
                    if (MainActivity._ERROR_LOG) {
                        RLog.e("Dcs", e.getMessage(), e);
                    }
                    info.sts = RowInfo.STS_EWOPEN;
                    return Dcs.OBS_STOP;
                }
                // エラーがない場合、継続
                info.sts = RowInfo.STS_SUCCESS;
                return Dcs.OBS_CONTINUE;
            }
            @Override
            public int write(byte[] buffer, int length, Object userInfo) {
                RowInfo info = (RowInfo) userInfo;
                try {
                    info.os.write(buffer, 0, length);
                } catch (IOException e) {
if (MainActivity._ERROR_LOG) {
RLog.e("Dcs", e.getMessage(), e);
}
                    try {
                        info.os.close();
                    } catch (IOException ex) {
if (MainActivity._ERROR_LOG) {
RLog.e("Dcs", ex.getMessage(), e);
}
                    }
                    info.os = null;
                    return Dcs.EWRITE;
                }
                // エラーがない場合、継続
                return Dcs.SUCCESS;
            }
        };
        return dcs;
    }

    public void onCheckboxClicked(CheckBox cbSelect) {
    }

    public void addHolder(RecyclerView.ViewHolder holder) {
        _selectionControler.addHolder(holder);
    }

    public void removeHolder(RecyclerView.ViewHolder holder) {
        _selectionControler.removeHolder(holder);
    }

    @Override
    public void selectAll(ArrayList<RecyclerView.ViewHolder> list, boolean isChecked) {
        int i, len = list.size();
        for(i=0;i<len;i++) {
            ConvertAdapter.ViewHolder holder = (ConvertAdapter.ViewHolder) list.get(i);
            View parent = MainActivity.getParent(holder.tvInfo, R.id.llRow);
            CheckBox cbSelect = parent.findViewById(R.id.cbSelect);
            cbSelect.setChecked(isChecked);
        }
    }
}
