package rabbit.dcs;

import android.graphics.Color;
import android.os.Parcelable;
import android.text.Spannable;
import android.text.SpannableStringBuilder;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.CheckBox;
import android.widget.HorizontalScrollView;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

public class ConvertAdapter<onCheckboxClicked>
        extends RecyclerView.Adapter<ConvertAdapter.ViewHolder>
        implements DcsAdapter {

    Parcelable[] _rowInfos;

    public ConvertAdapter(Parcelable[] rowInfos) {
        this._rowInfos = rowInfos;
    }

    static class ViewHolder extends RecyclerView.ViewHolder
            implements DcsViewHolder {
        RowInfo rowInfo;
        CheckBox cbSelect;
        TextView tvInfo;

        ViewHolder(View v) {
            super(v);
            cbSelect = v.findViewById(R.id.cbSelect);
            tvInfo = v.findViewById(R.id.tvInfo);
//            tvInfo.setTypeface(Typeface.MONOSPACE);
        }

        @Override
        public RowInfo getRowInfo() {
            return rowInfo;
        }
    }

    @Override
    public void onViewRecycled (@NonNull ConvertAdapter.ViewHolder holder) {
        ConvertActivity.getContext().removeHolder(holder);
    }

    // Create new views (invoked by the layout manager)
    @Override
    @NonNull
    public ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        try {
        // create a new view
        View view = LayoutInflater.from(parent.getContext())
                .inflate(R.layout.row_convert, parent, false);
        // set the view's size, margins, paddings and layout parameters
        return new ViewHolder(view);
    } catch(Exception e) {
        if (MainActivity._ERROR_LOG) {
            RLog.e("Dcs", e.getMessage(), e);
        }
    }
        return null;
    }

    // Replace the contents of a view (invoked by the layout manager)
    @Override
    public void onBindViewHolder(@NonNull ViewHolder holder, int position) {
        try {
        // - get element from your dataset at this position
        // - replace the contents of the view with that element
        ConvertActivity convertActivity = ConvertActivity.getContext();
        convertActivity.addHolder(holder);
        int fgcolor = Color.rgb(0x10, 0x10, 0x10);
        int bgcolor = MainActivity.getSeasonColor();
        int bgcolor0 = MainActivity.getSeasonColor(1.1F);
        /*DEBUGここから背景色 1/2*/
        holder.tvInfo.setTextColor(fgcolor);

        holder.tvInfo.setBackgroundColor(bgcolor);
        holder.cbSelect.setBackgroundColor(bgcolor);
        /*DEBUGここまで背景色 1/2*/
        RowInfo info = (RowInfo) _rowInfos[position];
        holder.rowInfo = info;
        holder.cbSelect.setChecked(info.isSelected);
        String strName = SettingsActivity.editPath(info.path, info.fileName);
        String strDate = info.date;
        String strSize = String.format("%6s", info.size);
        String strType = info.typeName;
        String strLType = info.ltype;
        String strMac = info.mac;
        String strMessage = info.message;
        SpannableStringBuilder ssb = new SpannableStringBuilder();
        boolean isStatusCheck = false;

        if (info.isDirectory) {
            strSize = "";
            strType = "";
        } else {
            // ファイルの時、かつ入出力可の時
            // ワーニングの背景色を設定
            isStatusCheck = true;
        }
        ssb.append(strName).append('\n');
        int len = ssb.length();
        ssb.append(strDate).append(' ').append(strSize);
        ssb.setSpan(
                new RelativeSizeMonospaceSpan(0.8f),
                len, // start
                ssb.length(), // end
                Spannable.SPAN_EXCLUSIVE_EXCLUSIVE
        );
        // ワーニングの背景色を設定
        MainActivity.setStatusColor(ssb, isStatusCheck? info.sts: RowInfo.STS_SUCCESS, strType, strLType, strMac, strMessage);
        holder.tvInfo.setText(ssb);
//
        View parentR = (View) holder.cbSelect.getParent();
        View parent2 = (View) holder.tvInfo.getParent();
        HorizontalScrollView svRow = (HorizontalScrollView) MainActivity.getParent(parent2, R.id.hsvRow);
        svRow.setBackgroundColor(bgcolor);
        /*DEBUGここから背景色 2/2*/
        parentR.setBackgroundColor(bgcolor);
        parent2.setBackgroundColor(bgcolor);
        MainActivity.setParentBackground(parentR, bgcolor0);
        /*DEBUGここまで背景色 2/2*/
        View pview = MainActivity.getParent(parent2, R.id.llRow);
        convertActivity.setListeners(pview, holder);

        } catch(Exception e) {
            if (MainActivity._ERROR_LOG) {
                RLog.e("Dcs", e.getMessage(), e);
            }
        }
    }

    // Return the size of your dataset (invoked by the layout manager)
    @Override
    public int getItemCount() {
        return _rowInfos.length;
    }

    @Override
    public RowInfo getRowInfo(int index) {
        return (RowInfo) _rowInfos[index];
    }
}
