package rabbit.dcs;

import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.os.Bundle;
import android.os.Parcel;
import android.os.Parcelable;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

import androidx.appcompat.app.AppCompatActivity;

public class EditActivity extends AppCompatActivity {

    private static EditActivity _editActivity;

    public static EditActivity getContext() {
        return _editActivity;
    }

    @Override
    protected void onDestroy () {
        super.onDestroy();
//DEBUG        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_UNSPECIFIED);
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

		setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        setContentView(R.layout.activity_edit);

        _editActivity = this;
        Intent intent = getIntent();
        Bundle bundle = intent.getExtras();
        EditInfo info = bundle.getParcelable(MainActivity.KEY_EDIT);
        setTitle(MainActivity._values.title);
        TextView tvGuidance = findViewById(R.id.tvGuidance);
        tvGuidance.setText(info.guidance);
        if (MainActivity._values instanceof ValuesJp) {
            tvGuidance.setTextSize(16);
        } else {
            tvGuidance.setTextSize(18);
        }
        TextView etValue = findViewById(R.id.etValue);
        etValue.setText(info.value.replaceAll("\\.", ""));
        Button bOk = findViewById(R.id.bOk);
        Button bCancel = findViewById(R.id.bCancel);
        bOk.setText(MainActivity._values.ok2);
        bCancel.setText(MainActivity._values.cancel);
        bOk.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                TextView etValue = findViewById(R.id.etValue);
                SettingsActivity settingsActivity = SettingsActivity.getContext();
                settingsActivity.setTypes(etValue.getText().toString(), info.isText);
                finish();
            }
        });
        bCancel.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                finish();
            }
        });
        int bgcolor = MainActivity.getSeasonColor(MainActivity._W_BGCOLOR);
        int bgcolor_text = MainActivity.getSeasonColor(MainActivity._W_BGCOLOR_TEXT);
        int fgcolor_text = MainActivity.getSeasonColor(MainActivity._W_FGCOLOR_TEXT);
        View view = findViewById(R.id.activity_edit);
        view.setBackgroundColor(bgcolor);
        etValue.setBackgroundColor(bgcolor_text);
        etValue.setTextColor(fgcolor_text);
        MainActivity.setButtonColor(bOk);
        MainActivity.setButtonColor(bCancel);
    }

    public static class EditInfo implements Parcelable {
        public boolean isText;
        public String title;
        public String guidance;
        public String value;

        public EditInfo() {
        }

        protected EditInfo(Parcel in) {
            isText = in.readByte() != 0;
            title = in.readString();
            guidance = in.readString();
            value = in.readString();
        }

        public static final Creator<EditInfo> CREATOR = new Creator<EditInfo>() {
            @Override
            public EditInfo createFromParcel(Parcel in) {
                return new EditInfo(in);
            }

            @Override
            public EditInfo[] newArray(int size) {
                return new EditInfo[size];
            }
        };

        @Override
        public int describeContents() {
            return 0;
        }

        @Override
        public void writeToParcel(Parcel parcel, int i) {
            parcel.writeByte((byte) (isText ? 1 : 0));
            parcel.writeString(title);
            parcel.writeString(guidance);
            parcel.writeString(value);
        }
    }
}
