package rabbit.dcs;

import android.content.pm.ActivityInfo;
import android.os.Bundle;
import android.util.DisplayMetrics;
import android.view.MotionEvent;
import android.view.ScaleGestureDetector;
import android.view.View;
import android.webkit.WebSettings;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.Button;
import android.widget.ImageButton;
import android.widget.TextView;

import androidx.appcompat.app.AppCompatActivity;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;

public class HelpActivity extends AppCompatActivity {

    static final String _COLOR_ = "_COLOR_";

//    static final String _FORMAT_ = "style=\"background-color:#%06x; color:#%06x;\"";
        static final String _FORMAT_ = "bgcolor=\"#%06x\" text=\"#%06x\"";

//!!    static final String _URL_HEAD = "file:///";

    private static HelpActivity _helpActivity;

    ScrollManager _scrollManager = new ScrollManager();

    static final int _ZOOM_MIN = 60;

    static final int _ZOOM_MAX = 150;

    int _zoom_b, _zoom = 100;

    float _scale;

    boolean _isPointerDown;

    public static HelpActivity getContext() {
        return _helpActivity;
    }

    @Override
    protected void onStart() {
        super.onStart();
    }

    @Override
    protected void onResume() {
        super.onResume();
    }

    int _scrollY;

    @Override
    protected void onStop() {
        super.onStop();

        MainActivity mainActivity = MainActivity.getContext();
        mainActivity.setProperty(MainActivity._property_key_help_y, String.valueOf(_scrollY));
    }
    boolean _isInit;

    @Override
    public void onWindowFocusChanged(boolean hasFocus) {
        super.onWindowFocusChanged(hasFocus);

        try {
        if (_isInit) {
            return;
        }
        _isInit = true;

        MainActivity mainActivity = MainActivity.getContext();
        WebView wvHelp = findViewById(R.id.wvHelp);
try{
    _scrollY = Integer.parseInt(mainActivity.getProperty(MainActivity._property_key_help_y));
} catch(Exception e) {
}
        if (_scrollY > 0) {
            wvHelp.setScrollY(_scrollY);
        }
        } catch (Exception e) {
            if (MainActivity._ERROR_LOG) {
                RLog.e("Dcs", e.getMessage(), e);
            }
        }
    }

    @Override
    protected void onDestroy () {
        super.onDestroy();
//DEBUG        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_UNSPECIFIED);
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        try {
		setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        setContentView(R.layout.activity_help);
        setTitle(MainActivity._values.title);

        _helpActivity = this;
        MainActivity mainActivity = MainActivity.getContext();

// リスナー登録
        String str;
        // 確認ボタン
        Button bOk = findViewById(R.id.bOk);
        bOk.setText(MainActivity._values.close);
        bOk.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                finish();
            }
        });
        // 前進／後退ボタン
        ImageButton ibBackward = findViewById(R.id.ibBackword);
        ibBackward.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                WebView wvHelp = findViewById(R.id.wvHelp);
                wvHelp.post(new Runnable() {
                    @Override
                    public void run() {
                        wvHelp.goBack();
                    }
                });
            }
        });
        ImageButton ibForward = findViewById(R.id.ibForword);
        ibForward.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                WebView wvHelp = findViewById(R.id.wvHelp);
                wvHelp.post(new Runnable() {
                    @Override
                    public void run() {
                        wvHelp.goForward();
                    }
                });
            }
        });
        // 上端／下端ボタン
        ImageButton ibDown = findViewById(R.id.ibDown);
        ibDown.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                WebView wvHelp = findViewById(R.id.wvHelp);
                DisplayMetrics dm = getResources().getDisplayMetrics();
                int sy = (int)(dm.scaledDensity * wvHelp.getContentHeight());
                wvHelp.setScrollY(sy);
            }
        });
        ImageButton ibUp = findViewById(R.id.ibUp);
        ibUp.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                WebView wvHelp = findViewById(R.id.wvHelp);
                wvHelp.post(new Runnable() {
                    @Override
                    public void run() {
                        wvHelp.setScrollY(0);
                    }
                });
            }
        });
            // ズーム・イン／ズーム・アウト・ボタン
        ImageButton ibZoomIn = findViewById(R.id.ibZoomIn);
        ImageButton ibZoomOut = findViewById(R.id.ibZoomOut);
        ibZoomIn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                int rem = _zoom % 5;
                checkZoom(rem == 0? _zoom + 5: _zoom + (5 - rem));
            }
        });
        ibZoomOut.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                int rem = _zoom % 5;
                checkZoom(rem == 0? _zoom - 5: _zoom - rem);
            }
        });
        // 上端／下端ボタンの背景色を設定
        int iBackward = R.drawable.ic_arrow_backward;
        int iForWard = R.drawable.ic_arrow_forward;
        int iUp = R.mipmap.ic_arrow_up_winter;
        int iDown = R.mipmap.ic_arrow_down_winter;

        int iZoomIn = R.drawable.ic_zoom_in;
        int iZoomOut = R.drawable.ic_zoom_out;

        ibBackward.setImageResource(iBackward);
        ibForward.setImageResource(iForWard);
        ibUp.setImageResource(iUp);
        ibDown.setImageResource(iDown);
        ibZoomIn.setImageResource(iZoomIn);
        ibZoomOut.setImageResource(iZoomOut);

        // setBackgroundColorによりAlpha が有効になる（値は無効）
        ibBackward.setBackgroundColor(0x101010);
        ibForward.setBackgroundColor(0x101010);
        ibZoomIn.setBackgroundColor(0x101010);
        ibZoomOut.setBackgroundColor(0x101010);

        WebView wvHelp = findViewById(R.id.wvHelp);
        WebSettings settings = wvHelp.getSettings();
        settings.setAllowFileAccess(true);
//
        wvHelp.setVerticalScrollBarEnabled(true);
        str = mainActivity.getProperty(MainActivity._property_key_help_zoom);
        int val = 100;
        try {
            val = Integer.parseInt(str);
        } catch(Exception e) {
        }
        checkZoom(val);
//
        wvHelp.setOverScrollMode(View.OVER_SCROLL_ALWAYS);
        wvHelp.setWebViewClient(new WebViewClient() {

            @Override
            public void onPageFinished(WebView view, String url) {
                super.onPageFinished(view, url);

                boolean canGoBack = wvHelp.canGoBack();
                boolean canGoForward = wvHelp.canGoForward();
                ibBackward.setEnabled(canGoBack);
                ibForward.setEnabled(canGoForward);
                ibBackward.setImageResource(canGoBack?
                        R.drawable.ic_arrow_backward: R.drawable.ic_arrow_backward_d);
                ibForward.setImageResource(canGoForward?
                        R.drawable.ic_arrow_forward: R.drawable.ic_arrow_forward_d);
            }
        });
        wvHelp.setOnScrollChangeListener(new View.OnScrollChangeListener() {
            @Override
            public void onScrollChange(View view, int x, int y, int oldx, int oldy) {
                _scrollY = y;
            }
        });

        ScaleGestureDetector sgd = new ScaleGestureDetector(this, new ScaleGestureDetector.OnScaleGestureListener() {
            @Override
            public boolean onScale(ScaleGestureDetector sgd) {
                _scale *= sgd.getScaleFactor();
                checkZoom(Math.round(_scale * _zoom_b));
                return true;
            }

            @Override
            public boolean onScaleBegin(ScaleGestureDetector sgd) {
                _zoom_b = _zoom;
                _scale = 1;
                return true;
            }

            @Override
            public void onScaleEnd(ScaleGestureDetector sgd) {
                // 最後のonScaleと同値なので省略
                //  onTouch: ACTION_POINTER_2_UP の処理を誤ると次の onScaleBegin の直前に発生してしまう
//!!                checkZoom(Math.round(_scale * _zoom_b));
            }
        });

        wvHelp.setOnTouchListener(new View.OnTouchListener() {
            @Override
            public boolean onTouch(View view, MotionEvent evt) {
                boolean isUp = false;
                switch (evt.getAction()) {
                    default:
                        break;
                    case MotionEvent.ACTION_DOWN:
                        _scrollManager.isContains(wvHelp, evt.getRawX(), evt.getRawY(), "initializing");
                        break;
                    case MotionEvent.ACTION_POINTER_DOWN:
                        _scrollManager._isInside = false;
                        _isPointerDown = true;
                        break;
                    case MotionEvent.ACTION_POINTER_2_DOWN:
                        _scrollManager._isInside = false;
                        _isPointerDown = true;
                        break;
                    case MotionEvent.ACTION_POINTER_3_DOWN:
                        _scrollManager._isInside = false;
                        _isPointerDown = true;
                        break;
                    case MotionEvent.ACTION_MOVE:
                        _scrollManager.moveTo(wvHelp, evt.getRawX(), evt.getRawY(), false, "initializing");
                        break;
                    case MotionEvent.ACTION_UP:
                        _scrollManager._isInside = false;
                        isUp = true;
                        break;
                    case MotionEvent.ACTION_POINTER_UP:
                        _scrollManager._isInside = false;
                        isUp = true;
                        break;
                    case MotionEvent.ACTION_POINTER_2_UP:
                        isUp = true;
                        break;
                    case MotionEvent.ACTION_POINTER_3_UP:
                        isUp = true;
                        break;
                    case MotionEvent.ACTION_CANCEL:
                        break;
                }
                boolean flag = false;
                if (isUp) {
                // 何れかがアップした時
                    _isPointerDown = sgd.isInProgress();
                    if (_isPointerDown) {
                        // 進行中であればイベント通知
                        flag = sgd.onTouchEvent(evt);
                    }
                } else if (_isPointerDown) {
                    // 何れかがダウン中であればイベント通知
                    flag = sgd.onTouchEvent(evt);
                }
                return flag;
            }
        });
        int fgcolor = MainActivity.getSeasonColor(0.05F);
        int bgcolor = MainActivity.getSeasonColor(1.2F);
// /storage/emulated/0/Android/data/rabbit.dcs/cache
        File pdir = mainActivity.getPrivateDir();
        File hdir = new File(pdir, "help");
        File idir = new File(hdir, "images");
        idir.mkdirs();
        File dfile = new File(hdir, "index.html");
            InputStream is = getAssets().open(MainActivity._values.helpPath);
            BufferedReader br = new BufferedReader(new InputStreamReader(is));
            PrintWriter pw = new PrintWriter(new BufferedWriter(new FileWriter(dfile)));
            while((str = br.readLine()) != null) {
                if (str.contains(_COLOR_)) {
                    str = str.replaceAll(_COLOR_, String.format(_FORMAT_, bgcolor & 0xffffff, fgcolor & 0xffffff));
                    pw.println(str);
                    while((str = br.readLine()) != null) {
                        pw.println(str);
                    }
                    break;
                }
                pw.println(str);
            }
            pw.close();
            br.close();
//!!        wvHelp.loadUrl(_URL_HEAD + dfile.getPath().substring(1));
        wvHelp.loadUrl(dfile.toURI().toURL().toString());
        View view = findViewById(R.id.activity_help);
        view.setBackgroundColor(MainActivity.getSeasonColor(MainActivity._W_BGCOLOR));
        MainActivity.setButtonColor(bOk);
        } catch (Exception e) {
            if (MainActivity._ERROR_LOG) {
                RLog.e("Dcs", e.getMessage(), e);
            }
        }
    }

    void checkZoom(int zoom) {
        zoom = _zoom = Math.min(_ZOOM_MAX, Math.max(_ZOOM_MIN, zoom));
        ImageButton ibZoomIn = findViewById(R.id.ibZoomIn);
        ImageButton ibZoomOut = findViewById(R.id.ibZoomOut);
        boolean notMaximun = (zoom < _ZOOM_MAX);
        boolean notMinimun = (zoom > _ZOOM_MIN);
        ibZoomIn.setEnabled(notMaximun);
        ibZoomOut.setEnabled(notMinimun);
        ibZoomIn.setImageResource(notMaximun? R.drawable.ic_zoom_in: R.drawable.ic_zoom_in_d);
        ibZoomOut.setImageResource(notMinimun? R.drawable.ic_zoom_out: R.drawable.ic_zoom_out_d);
        TextView tvZoom = findViewById(R.id.tvZoom);
        tvZoom.setText(String.format("%-3d%%", zoom));
        WebView wvHelp = findViewById(R.id.wvHelp);
        wvHelp.getSettings().setTextZoom(zoom);
        MainActivity.getContext().setProperty(MainActivity._property_key_help_zoom, String.valueOf(zoom));
    }

    public int getSelectedCount() {
        TextView tvCount = findViewById(R.id.tvCount);
        return Integer.parseInt(((String)tvCount.getText()).trim());
    }

    public void setSelectedCount(int count) {
        TextView tvCount = findViewById(R.id.tvCount);
        tvCount.setText(String.valueOf(count));
    }
}
