package rabbit.dcs;


import android.graphics.Point;
import android.os.Parcel;
import android.os.Parcelable;

import java.io.File;
import java.io.OutputStream;

public class RowInfo implements Parcelable {

    public static final int STS_SUCCESS = 0;
    public static final int STS_WNIDENT = 0000001;
    public static final int STS_WNOLN = 0000002;
    public static final int STS_WMIXEDLN = 0000004;
    public static final int STS_WUTF8_MAC = 0000010;
    public static final int STS_WOVERR = 0000020;
    public static final int STS_EWOPEN = -1;
    public static final int STS_EWRITE = -2;

    File file;
    int type;
    int icon;
    int scnt;
    int vcnt;
    int ecnt;
    boolean isMoved;
    String fileName;
    String displayName;
    String date;
    String size;
    String typeName;
    String ltype;
    String mac = "";
    String message = "";
    // 別アプリで非同期にされている可能性あり
    boolean isDirectory;
    // 別アプリで非同期にされている可能性あり
    boolean isEmptyDirectory;
    boolean isSelected;
    long clickTime;
    OutputStream os;
    String path;
    // row の最下位位置
    Point point;
    int sts;

    public RowInfo() {
    }

    protected RowInfo(Parcel in) {
        type = in.readInt();
        icon = in.readInt();
        scnt = in.readInt();
        fileName = in.readString();
        displayName = in.readString();
        date = in.readString();
        size = in.readString();
        typeName = in.readString();
        ltype = in.readString();
        mac = in.readString();
        isDirectory = in.readByte() != 0;
        isEmptyDirectory = in.readByte() != 0;
        isSelected = in.readByte() != 0;
        clickTime = in.readLong();
        path = in.readString();
        sts = in.readInt();
        file = new File(path);
    }


    public static final Creator<RowInfo> CREATOR = new Creator<RowInfo>() {
        @Override
        public RowInfo createFromParcel(Parcel in) {
            return new RowInfo(in);
        }

        @Override
        public RowInfo[] newArray(int size) {
            return new RowInfo[size];
        }
    };

    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel parcel, int i) {
        parcel.writeInt(type);
        parcel.writeInt(icon);
        parcel.writeInt(scnt);
        parcel.writeString(fileName);
        parcel.writeString(displayName);
        parcel.writeString(date);
        parcel.writeString(size);
        parcel.writeString(typeName);
        parcel.writeString(ltype);
        parcel.writeString(mac);
        parcel.writeByte((byte) (isDirectory ? 1 : 0));
        parcel.writeByte((byte) (isEmptyDirectory ? 1 : 0));
        parcel.writeByte((byte) (isSelected ? 1 : 0));
        parcel.writeLong(clickTime);
        parcel.writeString(path);
        parcel.writeInt(sts);
    }
}
