/*
 * _eucto_jis.c
 *
 * Copyright 2019-2023 Ichiji Tadokoro. All Rights Reserved.
 */

#include "_dcs.h"

int _eucto_jis(Dcs *dcs) {
	int tsts, sts = DCS_SUCCESS;
	int c, flag_shift = STYPE_ASCII;			/* ｼﾌﾄOUT */
	const unsigned char *tp, *sp, *ep;
	unsigned char *dbuf, *dp;
	int ltype = dcs->_type;
	ll_list *tlist, *clist = ll_first((ll_list *)dcs->_block);
	BufferInfo *tbinfo, *binfo = ll_get(clist);

	sp = binfo->buf + binfo->offset;
	ep = binfo->buf + binfo->length;
	reset_no_char(dcs, sp);
	dbuf = dp = _buffser_info.buf;

	for(;;) {
		/* 残りが最大長に満たない時、次の入力バッファに移動 */
		check_ll_buf(dcs, sp, ep, 3, clist, tlist, binfo, tbinfo);
		/* 出力バッファ・サイズを超える時、ライター出力 */
		check_info_buf_break(dcs, dp, dbuf, sizeof(_buffser_info.buf) - _MAX_JIS_OFFSET, sts);
		if (sp >= ep) {
			break;
		}
		tp = sp;
		if ((c = (*sp++ & 0xff)) >= 0xa1) {
			if (sp >= ep) {
				sts = DCS_EUEXPEOD;
				break;
			}
			c = ((c<<8)|(*sp++ & 0xff));
			/* 第４引数 c はエラー時に judge_unibe_to_jis_short_sp で処理する */
			judge_euc_to_jis_short_sp(dcs, dp, c, c, tp, flag_shift);
		} else if (c == 0x8e) {			/* EUCｶﾅ第１ﾊﾞｲﾄ */
			if (sp >= ep) {
				sts = DCS_EUEXPEOD;
				break;
			}
			c = (*sp++ & 0xff);
			if (flag_shift != STYPE_KANA) {
				*dp++ = (_ESC_CHAR);		/* ｴｽｹｰﾌﾟ(0x1b) */
				*dp++ = ('(');			/* JISｼﾌﾄOUT */
				*dp++ = ('I');			/* JIS半角ｶﾅ */
				flag_shift = STYPE_KANA;
			}
			*dp++ = (sjis_kana_to_jis(c));
		} else if (c == 0x8f) {			/* EUC３バイト第１ﾊﾞｲﾄ */
			if (sp + 2 > ep) {
				sts = DCS_EUEXPEOD;
				break;
			}
			c = (0x8f0000 | char_to_short(sp));
			/* 第４引数 c はエラー時に judge_unibe_to_jis_short_sp で処理する */
			judge_euc_to_jis_short_sp(dcs, dp, c, c, tp, flag_shift);
			/* FA5C'?\'-FC4A'?J' */
			sp += 2;
		} else {
			if (flag_shift != STYPE_ASCII) {
				*dp++ = (_ESC_CHAR);			/* ｴｽｹｰﾌﾟ(0x1b) */
				*dp++ = ('(');				/* JISｼﾌﾄOUT */
				*dp++ = (_SHIFT_OUT);		/* ﾛｰﾏ字 */
				flag_shift = STYPE_ASCII;	/* ｼﾌﾄOUT */
			}
			cnvln_stype_to_jis(dp, c, sp, ep, ltype, euc);
		}
	}
	if (sts == DCS_SUCCESS || sts == DCS_EUEXPEOD) {
		if (flag_shift != STYPE_ASCII) {
			*dp++ = (_ESC_CHAR);		/* ｴｽｹｰﾌﾟ(0x1b) */
			*dp++ = ('(');			/* JISｼﾌﾄOUT */
			*dp++ = (_SHIFT_OUT);	/* ﾛｰﾏ字 */
		}
		/* 出力バッファの残りをライター出力 */
		check_info_buf_rem(dcs, dp, dbuf, tsts);
		if (tsts != DCS_SUCCESS) {
			sts = tsts;
		}
	}
	DCS_RETURN(dcs, sts);
}
