/*
 * _unileto_jis.c
 *
 * Copyright 2019-2023 Ichiji Tadokoro. All Rights Reserved.
 */

#include "_dcs.h"

int _unileto_jis(Dcs *dcs) {
	int tsts, sts = DCS_SUCCESS;
	int flag_shift = STYPE_ASCII;			/* ｼﾌﾄOUT */
	int c, c2;
	const unsigned char *sp, *ep;
	unsigned char *dbuf, *dp;
	int ltype = dcs->_type;
	ll_list *tlist, *clist = ll_first((ll_list *)dcs->_block);
	BufferInfo *tbinfo, *binfo = ll_get(clist);

	sp = binfo->buf + binfo->offset;
	ep = binfo->buf + binfo->length;
	reset_no_char(dcs, sp);
	dbuf = dp = _buffser_info.buf;

	for(;;) {
		/* 残りが最大長に満たない時、次の入力バッファに移動 */
		check_ll_buf(dcs, sp, ep, 4, clist, tlist, binfo, tbinfo);
		/* 出力バッファ・サイズを超える時、ライター出力 */
		check_info_buf_break(dcs, dp, dbuf, sizeof(_buffser_info.buf) - _MAX_JIS_OFFSET, sts);
		if (sp + 1 >= ep) {
			if (sp < ep) {
				sts = DCS_EUEXPEOD;
			}
			break;
		}
		c = unile_to_unibe_char(sp);
		sp += 2;
		if ((c & 0xff80) == 0 || c == _UYEN) {
		/* ASCII の時 */
			if (c == _UYEN) {
				c = '\\';
			}
			if (flag_shift != STYPE_ASCII) {
				*dp++ = (_ESC_CHAR);		/* ｴｽｹｰﾌﾟ(0x1b) */
				*dp++ = ('(');			/* JISｼﾌﾄOUT */
				*dp++ = (_SHIFT_OUT);			/* ﾛｰﾏ字 */
				flag_shift = STYPE_ASCII;	/* ｼﾌﾄOUT */
			}
			cnvln_stype_to_jis(dp, c, sp, ep, ltype, unile);
		} else if (is_unibe_kana(c)) {
		/* 半角カナの時 */
			if (flag_shift != STYPE_KANA) {
				*dp++ = (_ESC_CHAR);		/* ｴｽｹｰﾌﾟ(0x1b) */
				*dp++ = ('(');			/* JISｼﾌﾄOUT */
				*dp++ = ('I');			/* JIS半角ｶﾅ */
				flag_shift = STYPE_KANA;
			}
			*dp++ = unibe_kana_to_jis(c);
		} else if (((c>>8)&0xff) == _ZEN_TILDE_0 && (c&0xff) == _ZEN_TILDE_1) {
		/* 全角'~'の時 */
			if (flag_shift != STYPE_ASCII) {
				*dp++ = (_ESC_CHAR);		/* ｴｽｹｰﾌﾟ(0x1b) */
				*dp++ = ('(');			/* JISｼﾌﾄOUT */
				*dp++ = (_SHIFT_OUT);		/* ﾛｰﾏ字 */
				flag_shift = STYPE_ASCII;	/* ｼﾌﾄOUT */
			}
			*dp++ = '~';
		} else {
		/* 全角の時 */
			UNILE_NFD_TO_NFC(dcs, c, sp, ep);
			c2 = (sp + 2 > ep? 0: unile_to_unibe_char(sp));
			/* Unicode(BE)(16bit)からJISコードへの変換 */
			judge_unibe_to_jis_short_sp(dcs, dp, c, c2, sp-2, flag_shift);
		}
	}
	if (sts == DCS_SUCCESS || sts == DCS_EUEXPEOD) {
		if (flag_shift != STYPE_ASCII) {
			*dp++ = (_ESC_CHAR);		/* ｴｽｹｰﾌﾟ(0x1b) */
			*dp++ = ('(');			/* JISｼﾌﾄOUT */
			*dp++ = (_SHIFT_OUT);			/* ﾛｰﾏ字 */
		}
		/* 出力バッファの残りをライター出力 */
		check_info_buf_rem(dcs, dp, dbuf, tsts);
		if (tsts != DCS_SUCCESS) {
			sts = tsts;
		}
	}
	DCS_RETURN(dcs, sts);
}
