/*
 * dcs_unibe_strln.c
 *
 * Copyright 2019-2023 Ichiji Tadokoro. All Rights Reserved.
 */

#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include "_dcs.h"

int dcs_unibe_strln(Dcs *dcs, char *dbuf, size_t dsize, size_t *pdsize, char **sbuf, size_t ssize) {
	int sts = 0;
	int cnt = 0;
	unsigned short ch;
	char *ptr = NULL;
	const unsigned char *sp, *ep, *tbuf;

	if (ssize > dsize) {
		ssize = dsize;
	}
	*pdsize = 0;
	tbuf = (unsigned char *)*sbuf;
	if ((*tbuf & 0xff) == UTF16_B0
	 && (*(tbuf + 1) & 0xff) == UTF16_B1) {
		sp = tbuf + 2;
	} else {
		sp = tbuf;
	}
//	if (((ssize - (sp - tbuf)) & 01) != 0) {
//		DCS_RETURN(dcs, DCS_EUEXPEOD);
//	}
	ep = (unsigned char *)*sbuf + ssize;
	while(sp < ep) {
		if (sp - tbuf + 1 >= ssize) {
//			sts = DCS_EUEXPEOD;
			break;
		}
		if (*sp == 0) {
			if (*(sp + 1) == '\n') {
				ptr = (char *)sp; /* ヌル文字から２バイト */
				sp += 2;
				break;
			} else if (*(sp + 1) == '\r') {
				ptr = (char *)sp; /* ヌル文字から２バイト */
				if (sp + 2 - tbuf < ssize && *(sp + 2) == 0 && *(sp + 3) == '\n') {
					sp += 4;
				} else {
					sp += 2;
				}
				break;
			}
		} else if (ch = (((*sp & 0xff) << 8) | (*(sp + 1) & 0xff)), is_unibe_surrogate_high(ch)) {
		/* サロゲート文字の時 */
			if (sp + 4 > ep) {
			/* 泣き別れの時 */
				if (sp - 2 > tbuf) {
					sp -= 2;
					break;
				}
			} else {
				sp += 2;
			}
		}
		sp += 2;
		cnt++;
	}
	if (ptr == NULL) {
	/* 改行がなかった時 */
		ptr = (char *)sp;
	}
	memcpy(dbuf, tbuf, ptr - (char *)tbuf);
	*pdsize = ptr - (char *)tbuf;
	/* 次の行頭 */
	*sbuf = (char *)sp;
	if (sts < 0) {
		DCS_RETURN(dcs, sts);
	}
	DCS_RETURN_COUNT(dcs, sts, cnt);
}
